// @generated by protobuf-ts 2.4.0 with parameter generate_dependencies,// @generated from protobuf file "Math/Math.proto" (package "math", syntax proto3),// tslint:disable
import type { RpcTransport } from "@protobuf-ts/runtime-rpc";
import type { ServiceInfo } from "@protobuf-ts/runtime-rpc";
import { MathSvc } from "./Math";
import type { FactorialRes } from "./Math";
import type { FactorialArg } from "./Math";
import { stackIntercept } from "@protobuf-ts/runtime-rpc";
import type { SumRes } from "./Math";
import type { SumArg } from "./Math";
import type { UnaryCall } from "@protobuf-ts/runtime-rpc";
import type { RpcOptions } from "@protobuf-ts/runtime-rpc";
/**
 * @generated from protobuf service math.MathSvc
 */
export interface IMathSvcClient {
    /**
     * @generated from protobuf rpc: Sum(math.SumArg) returns (math.SumRes);
     */
    sum(input: SumArg, options?: RpcOptions): UnaryCall<SumArg, SumRes>;
    /**
     * @generated from protobuf rpc: Factorial(math.FactorialArg) returns (math.FactorialRes);
     */
    factorial(input: FactorialArg, options?: RpcOptions): UnaryCall<FactorialArg, FactorialRes>;
}
/**
 * @generated from protobuf service math.MathSvc
 */
export class MathSvcClient implements IMathSvcClient, ServiceInfo {
    typeName = MathSvc.typeName;
    methods = MathSvc.methods;
    options = MathSvc.options;
    constructor(private readonly _transport: RpcTransport) {
    }
    /**
     * @generated from protobuf rpc: Sum(math.SumArg) returns (math.SumRes);
     */
    sum(input: SumArg, options?: RpcOptions): UnaryCall<SumArg, SumRes> {
        const method = this.methods[0], opt = this._transport.mergeOptions(options);
        return stackIntercept<SumArg, SumRes>("unary", this._transport, method, opt, input);
    }
    /**
     * @generated from protobuf rpc: Factorial(math.FactorialArg) returns (math.FactorialRes);
     */
    factorial(input: FactorialArg, options?: RpcOptions): UnaryCall<FactorialArg, FactorialRes> {
        const method = this.methods[1], opt = this._transport.mergeOptions(options);
        return stackIntercept<FactorialArg, FactorialRes>("unary", this._transport, method, opt, input);
    }
}
